// -*- mode:c++ -*-
//
// Header file LookaheadContext.hh
//
// Copyright (c) 2001 Raoul M. Gough
//
// History
// =======
// 2001/ 7/28	rmg	File creation
//

#ifndef LookaheadContext_included
#define LookaheadContext_included

#include <deque>
#include <vector>
#include <iosfwd>
#include <utility>
#include "SMLState.hh"

class LookaheadContext
{
  friend std::ostream& operator<< (std::ostream&, const LookaheadContext&);

public:
  typedef int Position;

public:
  LookaheadContext (void);

public:
  void add (SMLState prev, SMLState now, Position);

public:
  void initHeads (void);

public:
  typedef std::vector<Position> PositionContainer;

  struct PositionStack
  {
    PositionContainer stack;
    PositionContainer::const_reverse_iterator head;

    inline PositionStack (void)
      : stack()
      , head ()
    {
    }

    inline void push_back (Position p)
    {
      stack.push_back (p);
    }
  };

public:
  std::vector<PositionStack> mFlagPos;
  std::vector<PositionStack> mUnderlinePos;
  std::vector<PositionStack> mSizePos;
  std::vector<PositionStack> mColourPos;
};

#endif // LookaheadContext_included
